#ifndef MITER_H
#define MITER_H

/*
 * Multiple Sequence Iterator
 */

#include "Vec.h"
#include "Seq.h"

using namespace std;

class MIter
{
	friend class Mseq;

	public:
	
	typedef Vec<Seq::iterator>::size_type size_type;
	typedef Vec<Seq::iterator>::iterator iterator;
	typedef Vec<Seq::iterator>::const_iterator const_iterator;

	MIter() { _data.resize(0); }

	iterator getBegin();
	iterator getIterator(size_type index);
	iterator getEnd();
	size_type getSize();
	bool hasLetters();
	char getConsensusChar();

	void copyChars(MIter &mi);

	bool operator<(const MIter &mi);
	bool operator>(const MIter &mi);
	bool operator<=(const MIter &mi);
	bool operator>=(const MIter &mi);
	bool operator==(const MIter &mi);
	bool operator!=(const MIter &mi);
	Seq::iterator &operator[](size_type index);
	/* ___Prefix only!___ You were warned! */
	MIter &operator++();
	MIter &operator--();
	MIter &operator+(Seq::size_type inc);
	MIter &operator-(Seq::size_type dec);
	
	private:
	
	Vec<Seq::iterator> _data;
	
};
#endif
