#include "CachedPatternSetSelector.h"

void CachedPatternSetSelector::getBestPatterns(TyphonNS::Pattern::size_type weight, TyphonNS::Pattern::size_type span, unsigned int numPatterns, Vec<TyphonNS::Pattern>& patterns)
{
	if (patterns.size() > numPatterns)
	{
		while (patterns.size() > numPatterns)
		{
			patterns.erase(patterns.end() - 1);
		}
		return;
	}

	//now add the cached
	Vec<TyphonNS::Pattern> patternCandidates;
	unsigned int diff = span > weight ? span - weight : 0;
	if (weight <= 7)
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("1110010010101");
			patternCandidates.push_back("1011011000011");
			patternCandidates.push_back("1010001101110");
			patternCandidates.push_back("1100101010011");
			patternCandidates.push_back("1111000110010");
			patternCandidates.push_back("1001010011011");
			patternCandidates.push_back("1100110100101");
			patternCandidates.push_back("1111000001101");
			patternCandidates.push_back("1000111010110");
			patternCandidates.push_back("1011101000101");
			patternCandidates.push_back("1000110001111");
			patternCandidates.push_back("1110010101100");
			patternCandidates.push_back("1001001110101");
			patternCandidates.push_back("1010010110011");
			patternCandidates.push_back("1110110001001");
			patternCandidates.push_back("1101001100011");
			patternCandidates.push_back("1100001011110");
			patternCandidates.push_back("1101010011100");
			patternCandidates.push_back("1000101101101");
			patternCandidates.push_back("1101010000111");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("11001010001101");
			patternCandidates.push_back("11100100110001");
			patternCandidates.push_back("10101001001011");
			patternCandidates.push_back("11000101011100");
			patternCandidates.push_back("10000110100111");
			patternCandidates.push_back("11011000010101");
			patternCandidates.push_back("11110110000010");
			patternCandidates.push_back("11010001001110");
			patternCandidates.push_back("10110001100101");
			patternCandidates.push_back("11000100101011");
			patternCandidates.push_back("10011101000011");
			patternCandidates.push_back("10100100110110");
			patternCandidates.push_back("11101011100000");
			patternCandidates.push_back("10100010110011");
			patternCandidates.push_back("11100001010011");
			patternCandidates.push_back("10010010001111");
			patternCandidates.push_back("11000110011010");
			patternCandidates.push_back("10101000011110");
			patternCandidates.push_back("10010110101001");
			patternCandidates.push_back("10110100010101");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("101000100100111");
			patternCandidates.push_back("110110000101010");
			patternCandidates.push_back("110101001100001");
			patternCandidates.push_back("110001010110100");
			patternCandidates.push_back("110010010000111");
			patternCandidates.push_back("110100100011001");
			patternCandidates.push_back("111001011001000");
			patternCandidates.push_back("100101000010111");
			patternCandidates.push_back("100011101000101");
			patternCandidates.push_back("101100001001011");
			patternCandidates.push_back("110011100000110");
			patternCandidates.push_back("100010001110011");
			patternCandidates.push_back("101010110001001");
			patternCandidates.push_back("101101101010000");
			patternCandidates.push_back("110000111100010");
			patternCandidates.push_back("111000001001101");
			patternCandidates.push_back("110001010001101");
			patternCandidates.push_back("101001000101110");
			patternCandidates.push_back("111011000001010");
			patternCandidates.push_back("101010000111001");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("1110010010001010");
			patternCandidates.push_back("1001010000110110");
			patternCandidates.push_back("1010100010000111");
			patternCandidates.push_back("1101001100100001");
			patternCandidates.push_back("1110010101100000");
			patternCandidates.push_back("1100010001001101");
			patternCandidates.push_back("1001000001101011");
			patternCandidates.push_back("1101000111000100");
			patternCandidates.push_back("1101000010010011");
			patternCandidates.push_back("1100100000101110");
			patternCandidates.push_back("1101010100011000");
			patternCandidates.push_back("1011000010100101");
			patternCandidates.push_back("1100110100000011");
			patternCandidates.push_back("1100110010110000");
			patternCandidates.push_back("1010001001010011");
			patternCandidates.push_back("1100001010101001");
			patternCandidates.push_back("1101001001001010");
			patternCandidates.push_back("1111110000000100");
			patternCandidates.push_back("1110000100011001");
			patternCandidates.push_back("1100011100000110");
		}
		else
		{
			patternCandidates.push_back("11100100100010100");
			patternCandidates.push_back("10100010100100011");
			patternCandidates.push_back("10010000001101110");
			patternCandidates.push_back("11001000011000011");
			patternCandidates.push_back("11100001010100100");
			patternCandidates.push_back("11010100010001001");
			patternCandidates.push_back("10010100111100000");
			patternCandidates.push_back("10100011000010110");
			patternCandidates.push_back("11010001001011000");
			patternCandidates.push_back("10010100000110011");
			patternCandidates.push_back("11010010001000101");
			patternCandidates.push_back("11001101100000010");
			patternCandidates.push_back("10101100000001101");
			patternCandidates.push_back("10100001001001011");
			patternCandidates.push_back("10001001100010101");
			patternCandidates.push_back("10101110001100000");
			patternCandidates.push_back("11000010000111010");
			patternCandidates.push_back("11000010000001111");
			patternCandidates.push_back("10001100010100110");
			patternCandidates.push_back("11011000010010100");
		}
	}
	else if (weight == 8)
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("11001001010111");
			patternCandidates.push_back("11110001100101");
			patternCandidates.push_back("11010100011011");
			patternCandidates.push_back("10011101001101");
			patternCandidates.push_back("10110110000111");
			patternCandidates.push_back("11101010110001");
			patternCandidates.push_back("11100110101100");
			patternCandidates.push_back("10001011111100");
			patternCandidates.push_back("11010010110011");
			patternCandidates.push_back("10111100101010");
			patternCandidates.push_back("11001010001111");
			patternCandidates.push_back("11100100011101");
			patternCandidates.push_back("10110101010011");
			patternCandidates.push_back("11011100100110");
			patternCandidates.push_back("11000111101001");
			patternCandidates.push_back("11111000001011");
			patternCandidates.push_back("10101011100011");
			patternCandidates.push_back("11011011001010");
			patternCandidates.push_back("10101100110011");
			patternCandidates.push_back("11010010111100");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("110101001000111");
			patternCandidates.push_back("110110010111000");
			patternCandidates.push_back("111000101001011");
			patternCandidates.push_back("101011000110011");
			patternCandidates.push_back("111010100010110");
			patternCandidates.push_back("100001101011110");
			patternCandidates.push_back("111010001101001");
			patternCandidates.push_back("110010011010101");
			patternCandidates.push_back("101001110011001");
			patternCandidates.push_back("110110100001011");
			patternCandidates.push_back("110011100100101");
			patternCandidates.push_back("101110000011101");
			patternCandidates.push_back("101110011000011");
			patternCandidates.push_back("101001010101101");
			patternCandidates.push_back("111000010110011");
			patternCandidates.push_back("100011111101000");
			patternCandidates.push_back("101100100100111");
			patternCandidates.push_back("110110010100110");
			patternCandidates.push_back("110001011100011");
			patternCandidates.push_back("101100010011110");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("1001101010000111");
			patternCandidates.push_back("1110010011001010");
			patternCandidates.push_back("1110000100101011");
			patternCandidates.push_back("1010011000011101");
			patternCandidates.push_back("1001000101011011");
			patternCandidates.push_back("1100010011110001");
			patternCandidates.push_back("1110101000010011");
			patternCandidates.push_back("1011001101000110");
			patternCandidates.push_back("1011100010101001");
			patternCandidates.push_back("1011010010110010");
			patternCandidates.push_back("1110110001000101");
			patternCandidates.push_back("1100101100001101");
			patternCandidates.push_back("1000110100110110");
			patternCandidates.push_back("1010000011100111");
			patternCandidates.push_back("1101010010001101");
			patternCandidates.push_back("1110101011100000");
			patternCandidates.push_back("1110000010011110");
			patternCandidates.push_back("1100011001001011");
			patternCandidates.push_back("1100100001101110");
			patternCandidates.push_back("1001010101100101");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("11100010010010101");
			patternCandidates.push_back("10110100011001100");
			patternCandidates.push_back("11011001010000011");
			patternCandidates.push_back("10001000101001111");
			patternCandidates.push_back("11010100001010011");
			patternCandidates.push_back("10111001000111000");
			patternCandidates.push_back("11010011000001101");
			patternCandidates.push_back("11000010110101100");
			patternCandidates.push_back("10100100100110101");
			patternCandidates.push_back("11100011001000011");
			patternCandidates.push_back("10111000101010010");
			patternCandidates.push_back("10011101000100110");
			patternCandidates.push_back("11100000010101011");
			patternCandidates.push_back("11000101000011110");
			patternCandidates.push_back("11001100001100101");
			patternCandidates.push_back("10010010000110111");
			patternCandidates.push_back("11101101110000000");
			patternCandidates.push_back("10110100010110010");
			patternCandidates.push_back("10101100001011001");
			patternCandidates.push_back("10001001110101001");
		}
		else
		{
			patternCandidates.push_back("110010010101110000");
			patternCandidates.push_back("111000010001001101");
			patternCandidates.push_back("110101000110000101");
			patternCandidates.push_back("110010100000100111");
			patternCandidates.push_back("110110001001011000");
			patternCandidates.push_back("111000101100010001");
			patternCandidates.push_back("101000010110100110");
			patternCandidates.push_back("101001000011001011");
			patternCandidates.push_back("101110010000010101");
			patternCandidates.push_back("100100010000111011");
			patternCandidates.push_back("110100010101000011");
			patternCandidates.push_back("110011100001001001");
			patternCandidates.push_back("110101101000010100");
			patternCandidates.push_back("100010001010001111");
			patternCandidates.push_back("110100110010001100");
			patternCandidates.push_back("100011000000111110");
			patternCandidates.push_back("110101001000101001");
			patternCandidates.push_back("101011101001100000");
			patternCandidates.push_back("101100100001010011");
			patternCandidates.push_back("110110000010100011");
		}
	}
	else if (weight == 9)
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("110110010100111");
			patternCandidates.push_back("110101100010111");
			patternCandidates.push_back("100011111001101");
			patternCandidates.push_back("110101011001011");
			patternCandidates.push_back("111001000111101");
			patternCandidates.push_back("110100111011100");
			patternCandidates.push_back("111100101100011");
			patternCandidates.push_back("101111000011011");
			patternCandidates.push_back("111011010100011");
			patternCandidates.push_back("100110101110101");
			patternCandidates.push_back("101101110100110");
			patternCandidates.push_back("111000100101111");
			patternCandidates.push_back("110011001110101");
			patternCandidates.push_back("111110001001101");
			patternCandidates.push_back("111011101001010");
			patternCandidates.push_back("111010110011001");
			patternCandidates.push_back("100111001011110");
			patternCandidates.push_back("101000011011111");
			patternCandidates.push_back("111000101011011");
			patternCandidates.push_back("101010111000111");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("1110001010110110");
			patternCandidates.push_back("1001101101000111");
			patternCandidates.push_back("1101010010011101");
			patternCandidates.push_back("1110110001010011");
			patternCandidates.push_back("1100001011101011");
			patternCandidates.push_back("1110100110001101");
			patternCandidates.push_back("1010011110001011");
			patternCandidates.push_back("1111011001010100");
			patternCandidates.push_back("1001010001101111");
			patternCandidates.push_back("1011001000011111");
			patternCandidates.push_back("1101011100100011");
			patternCandidates.push_back("1001110010110011");
			patternCandidates.push_back("1110001101000111");
			patternCandidates.push_back("1011110101001001");
			patternCandidates.push_back("1011000111110100");
			patternCandidates.push_back("1010100100110111");
			patternCandidates.push_back("1100110101001110");
			patternCandidates.push_back("1111100001100101");
			patternCandidates.push_back("1101100110010110");
			patternCandidates.push_back("1110101000101011");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("11010011000101011");
			patternCandidates.push_back("11101000011001011");
			patternCandidates.push_back("10011100100100111");
			patternCandidates.push_back("10110001111010001");
			patternCandidates.push_back("11101001010100110");
			patternCandidates.push_back("11101110000001101");
			patternCandidates.push_back("10010100011001111");
			patternCandidates.push_back("10100010110110101");
			patternCandidates.push_back("11011100010110001");
			patternCandidates.push_back("11000010111011010");
			patternCandidates.push_back("11010001001010111");
			patternCandidates.push_back("10100110011100011");
			patternCandidates.push_back("10100101100001111");
			patternCandidates.push_back("11101000101010110");
			patternCandidates.push_back("11001001100011011");
			patternCandidates.push_back("11111001001101000");
			patternCandidates.push_back("11001010010111100");
			patternCandidates.push_back("11101010000110011");
			patternCandidates.push_back("10101100010010111");
			patternCandidates.push_back("11011000111000101");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("110101001001000111");
			patternCandidates.push_back("111000110111010000");
			patternCandidates.push_back("111001010100001101");
			patternCandidates.push_back("110100110000101011");
			patternCandidates.push_back("110010000010110111");
			patternCandidates.push_back("101100101100010011");
			patternCandidates.push_back("101010001001101011");
			patternCandidates.push_back("110110001010011100");
			patternCandidates.push_back("100011110100000111");
			patternCandidates.push_back("111100010100100110");
			patternCandidates.push_back("110010001100101101");
			patternCandidates.push_back("100001010101110011");
			patternCandidates.push_back("101101001010001101");
			patternCandidates.push_back("110001000111001011");
			patternCandidates.push_back("101110000011010101");
			patternCandidates.push_back("110100110010010101");
			patternCandidates.push_back("110001100000111110");
			patternCandidates.push_back("111011100010001001");
			patternCandidates.push_back("110110100101100001");
			patternCandidates.push_back("100110100011001110");
		}
		else
		{
			patternCandidates.push_back("1100101001000101110");
			patternCandidates.push_back("1101000100001101011");
			patternCandidates.push_back("1100100011010010011");
			patternCandidates.push_back("1111100010100011000");
			patternCandidates.push_back("1101001100010010101");
			patternCandidates.push_back("1010100101101000011");
			patternCandidates.push_back("1000101100011101100");
			patternCandidates.push_back("1110010000010100111");
			patternCandidates.push_back("1101010000110011010");
			patternCandidates.push_back("1001110011000001011");
			patternCandidates.push_back("1100001011001010101");
			patternCandidates.push_back("1010110000010011101");
			patternCandidates.push_back("1011001001100000111");
			patternCandidates.push_back("1110001101010001001");
			patternCandidates.push_back("1110110100101100000");
			patternCandidates.push_back("1101100010001000111");
			patternCandidates.push_back("1001010000100110111");
			patternCandidates.push_back("1100000011110101100");
			patternCandidates.push_back("1010111000001001011");
			patternCandidates.push_back("1010011101000010110");
		}
	}
	else if (weight == 10)
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("1101100011010111");
			patternCandidates.push_back("1111010100011011");
			patternCandidates.push_back("1110010111100101");
			patternCandidates.push_back("1011101001001111");
			patternCandidates.push_back("1101101110110001");
			patternCandidates.push_back("1100011101010111");
			patternCandidates.push_back("1101011011001011");
			patternCandidates.push_back("1110111000011101");
			patternCandidates.push_back("1010010001111111");
			patternCandidates.push_back("1111001010100111");
			patternCandidates.push_back("1110001011011110");
			patternCandidates.push_back("1010111100110011");
			patternCandidates.push_back("1001111100101101");
			patternCandidates.push_back("1110100010111011");
			patternCandidates.push_back("1101100011101101");
			patternCandidates.push_back("1101010011110011");
			patternCandidates.push_back("1110100110001111");
			patternCandidates.push_back("1000101111011101");
			patternCandidates.push_back("1100101001101111");
			patternCandidates.push_back("1100110101011011");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("11101010010110011");
			patternCandidates.push_back("11010011000101111");
			patternCandidates.push_back("11110100110010101");
			patternCandidates.push_back("11001010111001101");
			patternCandidates.push_back("11001100001111011");
			patternCandidates.push_back("10101110100100111");
			patternCandidates.push_back("11011001111000011");
			patternCandidates.push_back("11111001010101100");
			patternCandidates.push_back("11100101010001111");
			patternCandidates.push_back("10110111001101010");
			patternCandidates.push_back("10110000100111111");
			patternCandidates.push_back("11100011100011011");
			patternCandidates.push_back("11110100001101101");
			patternCandidates.push_back("10100011011110101");
			patternCandidates.push_back("11001101100101101");
			patternCandidates.push_back("11011110010000111");
			patternCandidates.push_back("10110101001010111");
			patternCandidates.push_back("11101011101000110");
			patternCandidates.push_back("11010110010111001");
			patternCandidates.push_back("11000110111010011");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("111010100100100111");
			patternCandidates.push_back("101100110001111010");
			patternCandidates.push_back("111000101010011011");
			patternCandidates.push_back("101101000110111100");
			patternCandidates.push_back("111011001011000101");
			patternCandidates.push_back("101101011100001011");
			patternCandidates.push_back("110001100101011101");
			patternCandidates.push_back("110110111001000011");
			patternCandidates.push_back("110100000111100111");
			patternCandidates.push_back("101110100011010101");
			patternCandidates.push_back("100111010010100111");
			patternCandidates.push_back("111100001100101101");
			patternCandidates.push_back("110101100110010011");
			patternCandidates.push_back("100110010100011111");
			patternCandidates.push_back("111011100000101011");
			patternCandidates.push_back("110001010011001111");
			patternCandidates.push_back("111100101111001000");
			patternCandidates.push_back("101011010101010011");
			patternCandidates.push_back("111101001000110011");
			patternCandidates.push_back("110100101100011110");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("1101010010011000111");
			patternCandidates.push_back("1011001110001011010");
			patternCandidates.push_back("1100110101000011011");
			patternCandidates.push_back("1110000100101010111");
			patternCandidates.push_back("1011101000100111001");
			patternCandidates.push_back("1011010001101001101");
			patternCandidates.push_back("1010110110000100111");
			patternCandidates.push_back("1111001011101100000");
			patternCandidates.push_back("1100100011100011101");
			patternCandidates.push_back("1111100001010000111");
			patternCandidates.push_back("1110011000110100011");
			patternCandidates.push_back("1100101010011001011");
			patternCandidates.push_back("1001001001011110101");
			patternCandidates.push_back("1101010100001101011");
			patternCandidates.push_back("1111001100010101100");
			patternCandidates.push_back("1110000101110101001");
			patternCandidates.push_back("1010011001100110110");
			patternCandidates.push_back("1100010110010011110");
			patternCandidates.push_back("1110111100001000101");
			patternCandidates.push_back("1010111101001110000");
		}
		else
		{
			patternCandidates.push_back("11010101100001101100");
			patternCandidates.push_back("10110010001010100111");
			patternCandidates.push_back("11100010100100011011");
			patternCandidates.push_back("11010000110011110001");
			patternCandidates.push_back("11101001011100000101");
			patternCandidates.push_back("11001100010010101011");
			patternCandidates.push_back("10011000001001111011");
			patternCandidates.push_back("11010110010100000111");
			patternCandidates.push_back("10111100010110011000");
			patternCandidates.push_back("11100101000011010011");
			patternCandidates.push_back("10110010011101010010");
			patternCandidates.push_back("10111000110001001101");
			patternCandidates.push_back("11010001101001000111");
			patternCandidates.push_back("10010100100110001111");
			patternCandidates.push_back("10100111100000101101");
			patternCandidates.push_back("11101001000001101110");
			patternCandidates.push_back("11000101001100101011");
			patternCandidates.push_back("11000100011001011101");
			patternCandidates.push_back("10111011101110000000");
			patternCandidates.push_back("11011011010000110001");
		}
	}
	else if (weight == 11)
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("11100100110101111");
			patternCandidates.push_back("10101111000110111");
			patternCandidates.push_back("11101110101001011");
			patternCandidates.push_back("11011011010101011");
			patternCandidates.push_back("11010110011111001");
			patternCandidates.push_back("11111000101100111");
			patternCandidates.push_back("10111001110011011");
			patternCandidates.push_back("11000011111010111");
			patternCandidates.push_back("11110010100111011");
			patternCandidates.push_back("11011101000111101");
			patternCandidates.push_back("10010101101101111");
			patternCandidates.push_back("11110011001011101");
			patternCandidates.push_back("10111001011110110");
			patternCandidates.push_back("11101111011000011");
			patternCandidates.push_back("11101000011011111");
			patternCandidates.push_back("11101001110110101");
			patternCandidates.push_back("11010101110110011");
			patternCandidates.push_back("11011110001010111");
			patternCandidates.push_back("11110100110011101");
			patternCandidates.push_back("11001111010011110");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("111011001010010111");
			patternCandidates.push_back("101100010111110011");
			patternCandidates.push_back("111001110100110101");
			patternCandidates.push_back("111101000011101101");
			patternCandidates.push_back("110100101110101011");
			patternCandidates.push_back("110110111001000111");
			patternCandidates.push_back("101110001100111110");
			patternCandidates.push_back("111010110100011011");
			patternCandidates.push_back("110101011001011011");
			patternCandidates.push_back("110011100110100111");
			patternCandidates.push_back("111100100111011100");
			patternCandidates.push_back("101001101100101111");
			patternCandidates.push_back("111101010101100110");
			patternCandidates.push_back("101111011010101001");
			patternCandidates.push_back("111000011000111111");
			patternCandidates.push_back("111110100001101011");
			patternCandidates.push_back("101110011110000111");
			patternCandidates.push_back("110011001101011101");
			patternCandidates.push_back("110011010001110111");
			patternCandidates.push_back("101010110101100111");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("1110100110010100111");
			patternCandidates.push_back("1010110001101101110");
			patternCandidates.push_back("1110011010001011101");
			patternCandidates.push_back("1111101001011000011");
			patternCandidates.push_back("1101100010101101011");
			patternCandidates.push_back("1100111101000010111");
			patternCandidates.push_back("1011001011100110011");
			patternCandidates.push_back("1111010001110001101");
			patternCandidates.push_back("1110101100110110100");
			patternCandidates.push_back("1010011100010101111");
			patternCandidates.push_back("1001110010011010111");
			patternCandidates.push_back("1111000100001111011");
			patternCandidates.push_back("1101010111000001111");
			patternCandidates.push_back("1110110100101010011");
			patternCandidates.push_back("1100001101110101011");
			patternCandidates.push_back("1011110111000011001");
			patternCandidates.push_back("1011001000110011111");
			patternCandidates.push_back("1101001011101100101");
			patternCandidates.push_back("1100110100100111101");
			patternCandidates.push_back("1011011000101100111");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("11101010010011000111");
			patternCandidates.push_back("10110011100010111100");
			patternCandidates.push_back("11100001010110110011");
			patternCandidates.push_back("11011101000100101101");
			patternCandidates.push_back("11000110110100011101");
			patternCandidates.push_back("10011100100011010111");
			patternCandidates.push_back("11010010001010101111");
			patternCandidates.push_back("11111001011000010101");
			patternCandidates.push_back("11010100101100110011");
			patternCandidates.push_back("11101001100011001011");
			patternCandidates.push_back("11101100001111000101");
			patternCandidates.push_back("11000101001001011111");
			patternCandidates.push_back("11001101110010100110");
			patternCandidates.push_back("10101111000100110110");
			patternCandidates.push_back("10110010110101010011");
			patternCandidates.push_back("10110110101010000111");
			patternCandidates.push_back("11101000001100111011");
			patternCandidates.push_back("11100011000001111101");
			patternCandidates.push_back("11010111101111000000");
			patternCandidates.push_back("11010000111101001101");
		}
		else
		{
			patternCandidates.push_back("110110001010100111100");
			patternCandidates.push_back("111100011001010010011");
			patternCandidates.push_back("111010100100001110011");
			patternCandidates.push_back("110000110110010011101");
			patternCandidates.push_back("101011011000010101011");
			patternCandidates.push_back("110100100011001101011");
			patternCandidates.push_back("111000101001111000101");
			patternCandidates.push_back("110101000101100010111");
			patternCandidates.push_back("100111010110001001011");
			patternCandidates.push_back("101110110010000010111");
			patternCandidates.push_back("111001000110100101101");
			patternCandidates.push_back("111101001110011001000");
			patternCandidates.push_back("110100101100110001110");
			patternCandidates.push_back("110011000001101100111");
			patternCandidates.push_back("110111010000011010101");
			patternCandidates.push_back("111000010101000101111");
			patternCandidates.push_back("110110001110010100011");
			patternCandidates.push_back("101010001000111110110");
			patternCandidates.push_back("101001000101111001011");
			patternCandidates.push_back("101100111000001101101");
		}
	}
	else 
	{
		if (diff <= 6)
		{
			patternCandidates.push_back("110101011001101111");
			patternCandidates.push_back("111110100111001011");
			patternCandidates.push_back("111010011010111011");
			patternCandidates.push_back("110011100101011111");
			patternCandidates.push_back("101100111110011101");
			patternCandidates.push_back("101111110000110111");
			patternCandidates.push_back("111001101011010111");
			patternCandidates.push_back("110110111010100111");
			patternCandidates.push_back("111111101000101101");
			patternCandidates.push_back("110111000111110011");
			patternCandidates.push_back("111100010100111111");
			patternCandidates.push_back("111010110101101101");
			patternCandidates.push_back("111001011111001011");
			patternCandidates.push_back("101011100110111011");
			patternCandidates.push_back("110110011101111001");
			patternCandidates.push_back("111010010111010111");
			patternCandidates.push_back("111101111100100011");
			patternCandidates.push_back("101111001110001111");
			patternCandidates.push_back("111101100010111011");
			patternCandidates.push_back("111101010111101100");
		}
		else if (diff == 7)
		{
			patternCandidates.push_back("1111010100110010111");
			patternCandidates.push_back("1100110101001111011");
			patternCandidates.push_back("1011011111000101011");
			patternCandidates.push_back("1111001001001110111");
			patternCandidates.push_back("1110101011110010011");
			patternCandidates.push_back("1100001110111101011");
			patternCandidates.push_back("1101100111010001111");
			patternCandidates.push_back("1010110001111101101");
			patternCandidates.push_back("1101111000101001111");
			patternCandidates.push_back("1111001100011011101");
			patternCandidates.push_back("1010100110101110111");
			patternCandidates.push_back("1011101101111000110");
			patternCandidates.push_back("1111010010101011011");
			patternCandidates.push_back("1100111011000011111");
			patternCandidates.push_back("1011110100110101011");
			patternCandidates.push_back("1111101100101100101");
			patternCandidates.push_back("1101101000110110111");
			patternCandidates.push_back("1101001101101011011");
			patternCandidates.push_back("1100111111001100101");
			patternCandidates.push_back("1110011100001111110");
		}
		else if (diff == 8)
		{
			patternCandidates.push_back("11110011001001010111");
			patternCandidates.push_back("10100101110001111011");
			patternCandidates.push_back("11101000101110100111");
			patternCandidates.push_back("11011110010100011011");
			patternCandidates.push_back("11011100100011101101");
			patternCandidates.push_back("11001101011010010111");
			patternCandidates.push_back("11101011101100111000");
			patternCandidates.push_back("11101011010101001101");
			patternCandidates.push_back("10110110000110110111");
			patternCandidates.push_back("11010011001110101011");
			patternCandidates.push_back("11000111110100100111");
			patternCandidates.push_back("11110100001100111101");
			patternCandidates.push_back("10101100111110001011");
			patternCandidates.push_back("11110100110001001111");
			patternCandidates.push_back("10111001010010110111");
			patternCandidates.push_back("11011101111000101010");
			patternCandidates.push_back("11100010100111110011");
			patternCandidates.push_back("11011001010101110011");
			patternCandidates.push_back("11111110001011000011");
			patternCandidates.push_back("11010011110010001111");
		}
		else if (diff == 9)
		{
			patternCandidates.push_back("111001010110010010111");
			patternCandidates.push_back("110111100011010101100");
			patternCandidates.push_back("111010001001110011011");
			patternCandidates.push_back("110100110100001111011");
			patternCandidates.push_back("101110011000101001111");
			patternCandidates.push_back("110010111011010100011");
			patternCandidates.push_back("111101000101100101011");
			patternCandidates.push_back("100101101010010011111");
			patternCandidates.push_back("101010000110011101111");
			patternCandidates.push_back("111100111100100010101");
			patternCandidates.push_back("110011100010111001011");
			patternCandidates.push_back("110111010000110110011");
			patternCandidates.push_back("110001011101011001110");
			patternCandidates.push_back("101111010011000011101");
			patternCandidates.push_back("111100101001010101101");
			patternCandidates.push_back("111101100001011010011");
			patternCandidates.push_back("101110001110100110011");
			patternCandidates.push_back("110010010110101110101");
			patternCandidates.push_back("110001001000101111111");
			patternCandidates.push_back("110110100110011010110");
		}
		else
		{
			patternCandidates.push_back("1110011001001001010111");
			patternCandidates.push_back("1110101011000111011000");
			patternCandidates.push_back("1111000010011101001101");
			patternCandidates.push_back("1101101001100010001111");
			patternCandidates.push_back("1010110110001010100111");
			patternCandidates.push_back("1100101100010110110011");
			patternCandidates.push_back("1110100111000001101011");
			patternCandidates.push_back("1110010000111100101011");
			patternCandidates.push_back("1010001101110001011101");
			patternCandidates.push_back("1011000010100011111011");
			patternCandidates.push_back("1011001101010100100111");
			patternCandidates.push_back("1101110100001100101101");
			patternCandidates.push_back("1010111011011010110000");
			patternCandidates.push_back("1110100100100100011111");
			patternCandidates.push_back("1101010001110011100011");
			patternCandidates.push_back("1111001100001011100101");
			patternCandidates.push_back("1101111010001010001011");
			patternCandidates.push_back("1100010010100101111110");
			patternCandidates.push_back("1101111010010000110101");
			patternCandidates.push_back("1111000011001100110011");
		}
	}
	for (unsigned int curPos = 0; curPos < patternCandidates.size() && patterns.size() < numPatterns; curPos++)
	{
		//check if already present
		bool present = false;
		for (Vec<TyphonNS::Pattern>::iterator it = patterns.begin(); it != patterns.end(); ++it)
		{
			if ((*it) == patternCandidates[curPos])
			{
				present = true;
				break;
			}
		}
		if (present)
		{
			continue;
		}
		patterns.push_back(patternCandidates[curPos]);
	}

} 
