#ifndef _mandalawrapper_h_included_
#define _mandalawrapper_h_included_

#include "System.h"
#include "TyphonMarkovModel.h"
#include "ProbVector.h"
#include "RegionList.h"
#include "Vec.h"
#include "Seq.h"
#include "Pattern.h"

#include "pattern.h"
#include "basicmarkovmodel.h"
#include "eval.h"
#include "eval-dp.h"

#include <sstream>
#include <set>

class MandalaWrapper
{
 public:

	typedef Pattern MandalaPattern;
	typedef BasicMarkovModel MandalaModel;

	static void getMandalaModel(TyphonMarkovModel& m, MandalaModel& mm);
	static double findNextBestPattern(unsigned int length, TyphonMarkovModel& tmm, Vec<TyphonNS::Pattern>& patternsAlready, unsigned int patternWeight, unsigned int patternSpan, TyphonNS::Pattern& resultPattern);

	static pair<double, Vec<TyphonNS::Pattern>::size_type> bestPattern(unsigned int length, TyphonMarkovModel& tmm, const Vec<TyphonNS::Pattern>& candidatePatterns, const Vec<Vec<TyphonNS::Pattern>::size_type>& patternsAlready);

	static double MandalaWrapper::evaluatePattern(unsigned int length, TyphonMarkovModel& tmm, const Vec<TyphonNS::Pattern>& candidatePatterns, const TyphonNS::Pattern::size_type patternToEvaluate, const Vec<Vec<TyphonNS::Pattern>::size_type>& patternsAlready);

	static double MandalaWrapper::evaluatePatterns(unsigned int length, TyphonMarkovModel& tmm, const Vec<TyphonNS::Pattern>& candidatePatterns);

	static MandalaPattern typhonToMandalaPattern(const TyphonNS::Pattern& from);
	static TyphonNS::Pattern mandalaToTyphonPattern(const MandalaPattern& from);

 private:

	static MandalaPattern _createRandomPattern(unsigned int weight, unsigned int span);

	static const unsigned int NUM_RESTARTS = 5;

};

#endif
