#ifndef _nextpatternsetgeneratorbyregionclass_h_included_
#define _nextpatternsetgeneratorbyregionclass_h_included_

#include "System.h"
#include "NextPatternSetGenerator.h"
#include "TyphonMarkovModel.h"
#include <map>

class NextPatternSetGeneratorByRegionClass : public NextPatternSetGenerator
{
 public:

	NextPatternSetGeneratorByRegionClass(bool eachRegion = false) : _eachRegion(eachRegion) {};

	typedef unsigned int size_type;
	typedef RegionList::region_attr_type region_attr_type;

	/**
	 * Fetch the next region and pattern set
	 */
	void nextPatternSet(Region& r, Vec<Vec<TyphonNS::Pattern>::size_type>& p);

 protected:

	void _initialize(const ProbVector& pv, const RegionList& r, const unsigned int budget, const unsigned int order);

 private:

	static const unsigned int MAX_REGION_LENGTH = 64;
	static const unsigned int MAX_REGION_LENGTH_FOR_MULTIPLE = 128;
	static const unsigned int NUM_REGION_LENGTHS = 4;

	//map from region types to the patterns to index
	map<region_attr_type, Vec<Vec<TyphonNS::Pattern>::size_type> > _regionClassToPatternSubset;
	//a list of the regions
	RegionList _regionList;
	//current region
	unsigned int _curRegion;
	
	bool _eachRegion;
	unsigned int _endPoint;

};

namespace NextPatternSetGeneratorByRegionClassNS
{
	bool compare(const pair<NextPatternSetGeneratorByRegionClass::region_attr_type, double>& a, const pair<NextPatternSetGeneratorByRegionClass::region_attr_type, double>& b);
}

#endif
