#ifndef _nextpatternsetgeneratoroneregion_h_included_
#define _nextpatternsetgeneratoroneregion_h_included_

#include "System.h"
#include "NextPatternSetGenerator.h"
#include "TyphonMarkovModel.h"

class NextPatternSetGeneratorOneRegion : public NextPatternSetGenerator
{
 public:

	typedef unsigned int size_type;

	/**
	 * Fetch the next region and pattern set
	 */
	void nextPatternSet(Region& r, Vec<Vec<TyphonNS::Pattern>::size_type>& p);

 protected:

	void _initialize(const ProbVector& pv, const RegionList& r, const unsigned int budget, const unsigned int order);

 private:

	static const unsigned int MAX_REGION_LENGTH = 128;

	size_type _start;
	size_type _end;
	TyphonMarkovModel _tmm;
	unsigned int _length;
};

#endif
