#include "OnePatternSetSelector.h"
#include "TyphonMarkovModel.h"

double OnePatternSetSelector::getBestPatterns(double simLevel, const Vec<TyphonNS::Pattern>::size_type numPatterns, const unsigned int patternWeight, const unsigned int patternSpan, Vec<TyphonNS::Pattern>& patterns)
{
  double allPMatch = 0.0;
	//first construct the markov model
	TyphonMarkovModel tmm(0);
	tmm.setPercentId(simLevel);

	unsigned int length = 0;
	//unsigned int numRegions = r.getNumRegions();
	//for (unsigned int i = 0; i < numRegions; i++)
	//{
	//	Region curRegion = r.getRegion(i);
	//	tmm.addCountsOf(pv, curRegion);
	//	length += curRegion.getLength();
	//}

	//if (numRegions)
	//{
	//	length /= numRegions;
	//}
	//if (length > MAX_REGION_LENGTH)
	//{
		length = MAX_REGION_LENGTH;
	//}

	unsigned int numToAdd = 0;

	if (patterns.size())
	{
		allPMatch = MandalaWrapper::evaluatePatterns(length, tmm, patterns);
	}

	if (patterns.size() < numPatterns)
	{
		numToAdd = numPatterns - patterns.size();
	}
	else
	{
		while (patterns.size() > numPatterns)
		{
			patterns.erase(patterns.end() - 1);
		}
		return allPMatch;
	}

  for (Vec<TyphonNS::Pattern>::size_type n = 0; n < patterns.size(); n++) 
	{
		//cerr << "Using pattern number " << n + 1 << "..." << endl;
		//cout << "Used " << patterns[n] << endl;
	}

  for (Vec<TyphonNS::Pattern>::size_type n = 0; n < numToAdd; n++) 
	{
		//cerr << "Picking pattern number " << n + 1 << "..." << endl;

		TyphonNS::Pattern nextPattern;

		double newProb = MandalaWrapper::findNextBestPattern(length, tmm, patterns, patternWeight, patternSpan, nextPattern);
		patterns.push_back(nextPattern);

		allPMatch = allPMatch + (1.0 - allPMatch) * newProb;
	}
  

	return allPMatch;
}
