#include "ProbVector.h"
#include "Profile.h"

const string ProbVector::TAG = "#ProbVector#";

ProbVector::ProbVector(Mseq& m, double pc)
{
	resize(m.getLength());
	MIter mEnd;
	m.getMIEnd(mEnd);
	Seq::size_type i = 0;
	MIter mIt;
	m.getMIBegin(mIt);

	for (; mIt != mEnd; ++mIt, ++i)
	{
		MIter::iterator end = mIt.getEnd();
		for (MIter::iterator it = mIt.getBegin(); it != end; ++it)
		{
			unsigned char letter = static_cast<unsigned char>(**it);
			if (letter == BIO::ANY_CHAR)
			{
				letter = BIO::GAP_CHAR;
			}
			_increment(i, CHAR_PROFILE_IDX[letter], 1);
		}
		for (DVector<DVector<prob_type> >::iterator it = _tuples.begin(); it != _tuples.end(); ++it)
		{
			(*it)[i] += pc;
		}
		_normalize(i);
	}
}

void ProbVector::readFromFile(const string& filename)
{
	ifstream is(filename.c_str());
	char* buffer = new char[TAG.size()];
	is.read(buffer, TAG.size());
	if (strncmp(buffer, TAG.c_str(), TAG.size()) != 0)
	{
		delete buffer;
		throw BIO::E_OpenFailedEx();		
	}
	else
	{
		delete buffer;
	}
	is >> _tuples;
}


void ProbVector::writeToFile(const string& filename)
{
	ofstream os(filename.c_str());
	os.write(TAG.c_str(), TAG.size());
	os << _tuples;
}
