#include <math.h>
#include "SimpleHMM.h"

SimpleHMM::SimpleHMM(Seq::size_type minRegionLength) : _minRegionLength(minRegionLength)
{
	//first we need to get the prob values around which we will build the gaussians
	//prob_type weightDiff = 1.0 / numWeights;
// 	for (Vec<prob_type>::size_type i = 0; i < numWeights; i++)
// 	{
// 		_weights.push_back(i * weightDiff + weightDiff / 2);
// 	}
// 	_weightDev = weightDiff;
// 	_numWeights = _weights.size();

// 	static const double RANDOM = .25;
// 	static const double BASE = .5;

// 	if (numConsLevels <= 1)
// 	{
// 		numConsLevels = 2;
// 	}
// 	_consLevels.push_back(RANDOM);
// 	state_number_type numConsLevelsLeft = numConsLevels - 1;
// 	prob_type consDiff = (1.0 - BASE) / (numConsLevelsLeft + 1);
// 	_consDev = consDiff;		
// 	for (Vec<prob_type>::size_type i = 1; i <= numConsLevelsLeft; i++)
// 	{
// 		_consLevels.push_back(BASE + i * consDiff);
// 	}
// 	_numConsLevels = _consLevels.size();

// 	//now determine transition probabilities
// 	_numStates = _numWeights * _numConsLevels;
// 	_logTransitionProb.resize(_numStates);
// 	for (Vec<Vec<prob_type> >::iterator it = _logTransitionProb.begin(); it != _logTransitionProb.end(); ++it)
// 	{
// 		it->resize(_numStates);
// 	}

// 	for (state_number_type i = 0; i < numWeights; i++)
// 	{
// 		for (state_number_type j = 0; j < numConsLevels; j++)
// 		{
// 			state_number_type currentFrom = getStateNumber(i,j);

// 			state_number_type furthestWeight = (i > (numWeights / 2)) ? 0 : numWeights - 1;
// 			state_number_type furthestConsLevel = (i > (numConsLevels / 2) + 1) ? 1 : numConsLevels - 1;
// 			prob_type weightDistance = fabs(static_cast<prob_type>(i) - static_cast<prob_type>(furthestWeight));
// 			prob_type consDistance = fabs(static_cast<prob_type>(j) - static_cast<prob_type>(furthestConsLevel)); 
// 			prob_type penalty = ((-1 * (weightDistance * weightDiff) / (2 * _weightDev * _weightDev)) - ((consDistance * consDiff) / (2 * _consDev * _consDev))) * minRegionLength * .5;
// 			for (state_number_type k = 0; k < numWeights; k++)
// 			{
// 				for (state_number_type l = 0; l < numConsLevels; l++)
// 				{
// 					if (i != k || j != l)
// 					{
// 						_logTransitionProb[currentFrom][getStateNumber(k,l)] = penalty;
// 					}
// 					else
// 					{
// 						_logTransitionProb[currentFrom][getStateNumber(k,l)] = 0;
// 					}
// 				}
// 			}
// 		}
// 	}
}

// void SimpleHMM::decode(const ProbVector& pv, RegionList& regionList)
// {
// 	//cerr << "Decoding into regions..." << endl;
// 	ProbVector::size_type numPos = pv.size();
// 	if (!numPos)
// 	{
// 		return;
// 	}
// 	//we first need to store the forward values
// 	Vec<Vec<prob_type> > values(_numStates);
// 	Vec<Vec<output_type> > backPtrs(_numStates);
// 	for (Vec<Vec<prob_type> >::size_type i = 0; i != _numStates; ++i)
// 	{
// 		values[i].resize(pv.size(), 0);
// 		backPtrs[i].resize(pv.size(), 0);
// 	}

// 	//base case
// 	for (state_number_type i = 0; i < _numWeights; i++)
// 	{
// 		for (state_number_type j = 0; j < _numConsLevels; j++)
// 		{
// 			state_number_type currentState = getStateNumber(i,j);
// 			values[currentState][0] = getLogEmissionProbability(pv, 0, _weights[i], _consLevels[j], _weightDev, _consDev);
// 			backPtrs[currentState][0] = 0;
// 		}
// 	}

// 	//now recurse
// 	for (Vec<output_type>::size_type i = 1; i < numPos; i++)
// 	{
// 		for (state_number_type j = 0; j < _numWeights; j++)
// 		{
// 			for (state_number_type k = 0; k < _numConsLevels; k++)
// 			{
// 				state_number_type currentState = getStateNumber(j, k);
// 				//get the maxK
// 				output_type maxPrevState = 0;
// 				prob_type maxPrevValue = 0;
// 				bool havePrev = false;
// 				for (state_number_type l = 0; l < _numWeights; l++)
// 				{
// 					for (state_number_type m = 0; m < _numConsLevels; m++)
// 					{
// 						state_number_type currentPrevState = getStateNumber(l, m);
// 						prob_type curVal = values[currentPrevState][i - 1] + _logTransitionProb[currentPrevState][currentState];
// 						if (!havePrev || curVal > maxPrevValue)
// 						{
// 							havePrev = true;
// 							maxPrevValue = curVal;
// 							maxPrevState = currentPrevState;
// 						}
// 					}
// 				}
// 				//now update
// 				values[currentState][i] = maxPrevValue + getLogEmissionProbability(pv, i, _weights[j], _consLevels[k], _weightDev, _consDev);
// 				backPtrs[currentState][i] = maxPrevState;
// 			}
// 		}
// 	}

// 	//now go in reverse
// 	output_type maxFinalState = 0;
// 	prob_type maxFinalValue = 0;
// 	bool haveFinalValue = false;
// 	for (state_number_type j = 0; j < _numWeights; j++)
// 	{
// 		for (state_number_type k = 0; k < _numConsLevels; k++)
// 		{
// 			state_number_type currentState = getStateNumber(j, k);
// 			if (!haveFinalValue || values[currentState][numPos - 1] > maxFinalValue)
// 			{
// 				maxFinalValue = values[currentState][numPos - 1];
// 				maxFinalState = currentState;
// 				haveFinalValue = true;
// 			}
// 		}
// 	}

// 	Vec<output_type> stateSequence(numPos);

// 	stateSequence[numPos - 1] = maxFinalState;
// 	for (Vec<output_type>::size_type i = numPos - 1; i > 0; i--)
// 	{
// 		stateSequence[i - 1] = backPtrs[stateSequence[i]][i];
// 	} 
// 	//now let's create the regions
// 	regionList.clear();
// 	Seq::size_type start = 0;
// 	Seq::size_type end = 0;	
// 	output_type currentOutput = stateSequence[0];
// 	for (Vec<output_type>::size_type i = 1; i < numPos; i++)
// 	{
// 		if (stateSequence[i] != currentOutput)
// 		{
// 			Region r(start, end);
// 			regionList.addRegion(r, _weights[getWeight(currentOutput)], _consLevels[getConsLevel(currentOutput)]);
// 			start = i;
// 			end = i;
// 			currentOutput = stateSequence[i];
// 		}
// 		else
// 		{
// 			end++;
// 		}
// 	}	
// 	Region r(start, end);
// 	regionList.addRegion(r, _weights[getWeight(currentOutput)], _consLevels[getConsLevel(currentOutput)]);
//}

void SimpleHMM::adaptiveDecode(const ProbVector& pv, const unsigned int numRegions, RegionList& regionList)
{
	//cerr << "Adaptively decoding into regions..." << endl;
	ProbVector::size_type numPos = pv.size();
	if (!numPos)
	{
		return;
	}

	Vec<unsigned int> budget(1, numRegions);
	Vec<prob_type> weightLowers(1, 0);
	Vec<prob_type> weightUppers(1, 1);
	Vec<prob_type> weights(1, (weightUppers[0] + weightLowers[0]) / 2);
	Vec<prob_type> consLowers(1, 0);
	Vec<prob_type> consUppers(1, 1);
	Vec<prob_type> consLevels(1, (consUppers[0] + consLowers[0]) / 2);
	Vec<unsigned int> stateNumbers(numPos, 0);

	for (unsigned int currentStateToSplit = 0; currentStateToSplit != budget.size(); currentStateToSplit++)
	{
		if (budget[currentStateToSplit] <= 1)
		{
			continue;
		}

		//okay, let's determine which one to split on. We want to split on which ever has the greatest discriminating power
		prob_type avgCons = 0;
		prob_type avgWeight = 0;
		prob_type lowerCons = 1;
		unsigned int lowerCPos = 0;
		prob_type lowerWeight = 1;
		unsigned int lowerWPos = 0;
		prob_type upperCons = 0;
		unsigned int upperCPos = 0;
		prob_type upperWeight = 0;
		unsigned int upperWPos = 0;
		prob_type avgConsSquared = 0;
		prob_type avgWeightSquared = 0;
		unsigned int numUsed = 0;

		for (unsigned int i = 0; i < numPos; i++)
		{
			if (stateNumbers[i] != currentStateToSplit)
			{
				continue;
			}
			prob_type pMax = pv.getMaxLetterProb(i);
			prob_type pPresent = pv.getPresentProbability(i);
			if (pPresent == 0)
			{
				continue;
			}
			if (pMax > upperCons)
			{
				upperCons = pMax;
				upperCPos = i;
			}
			else if (pMax < lowerCons)
			{
				lowerCons = pMax; 
				lowerCPos = i;
			}
			if (pPresent > upperWeight)
			{
				upperWeight = pPresent;
				upperWPos = i;
			}
			else if (pPresent < lowerWeight)
			{
				lowerWeight = pPresent; 
				lowerWPos = i;
			}

			avgCons += pMax;
			avgWeight += pPresent;
			avgConsSquared += (pMax * pMax);
			avgWeightSquared += (pPresent * pPresent);

			numUsed++;
		}

		if (!numUsed)
		{
			continue;
		}
		avgCons /= numUsed;
		avgWeight /= numUsed;
		avgConsSquared /= numUsed;
		avgWeightSquared /= numUsed;

		prob_type devCons = sqrt(avgConsSquared - avgCons * avgCons);
		prob_type devWeight = sqrt(avgWeightSquared - avgWeight * avgWeight);

		//now get the values in a condensed form
		Vec<prob_type> weightValues(numUsed);
		Vec<prob_type> consValues(numUsed);
		unsigned int j = 0;
		bool inRegion = false;
		Vec<prob_type> weightValuesForRegions;
		Vec<prob_type> consValuesForRegions;
		Vec<prob_type> weightNumForRegions;
		Vec<prob_type> consNumForRegions;

		for (unsigned int i = 0; i < numPos; i++)
		{
			if (stateNumbers[i] != currentStateToSplit)
			{
				inRegion = false;
				continue;
			}
			prob_type pMax = pv.getMaxLetterProb(i);
			prob_type pPresent = pv.getPresentProbability(i);
			if (pPresent == 0)
			{
				continue;
			}

			if (!inRegion)
			{
				weightValuesForRegions.push_back(0);
				consValuesForRegions.push_back(0);
				weightNumForRegions.push_back(0);
				consNumForRegions.push_back(0);
				inRegion = true;
			}
			consValues[j] = pMax;
			weightValues[j] = pPresent;

			weightValuesForRegions.back() += weightValues[j];
			consValuesForRegions.back() += consValues[j];

			weightNumForRegions.back()++;
			consNumForRegions.back()++;

			j++;
		}

		sort(consValues.begin(), consValues.end());
		sort(weightValues.begin(), weightValues.end());

		prob_type lowerConsMean = 0;
		prob_type upperConsMean = 0;
		unsigned int numConsLower = 0;
		unsigned int numConsUpper = 0;
		prob_type lowerWeightMean = 0;
		prob_type upperWeightMean = 0;
		unsigned int numWeightLower = 0;
		unsigned int numWeightUpper = 0;

		const unsigned int maxNumDevs = 3;

		for (unsigned int i = 0; i < numUsed; i++)
		{
			if (fabs(consValues[i] - avgCons) < maxNumDevs * devCons)
			{
				if (consValues[i] <= avgCons)
				{
					lowerConsMean += consValues[i];
					numConsLower++;
				}
				else
				{
					upperConsMean += consValues[i];
					numConsUpper++;
				}
			}

			if (fabs(weightValues[i] - avgWeight) < maxNumDevs * devWeight)
			{
				if (weightValues[i] <= avgWeight)
				{
					lowerWeightMean += weightValues[i];
					numWeightLower++;
				}
				else
				{
					upperWeightMean += weightValues[i];
					numWeightUpper++;
				}
			}
		}
		if (!numConsLower || !numConsUpper)
		{
			devCons = 0;
			lowerConsMean = avgCons;
			upperConsMean = avgCons;
		}
		else
		{
			lowerConsMean /= numConsLower;
			upperConsMean /= numConsUpper;
		}

		if (!numWeightLower || !numWeightUpper)
		{
			devWeight = 0;
			lowerWeightMean = avgWeight;
			upperWeightMean = avgWeight;
		}
		else
		{
			lowerWeightMean /= numWeightLower;
			upperWeightMean /= numWeightUpper;
		}

		//cout << endl << "Splitting " << currentStateToSplit << ": " << weights[currentStateToSplit] << "," << consLevels[currentStateToSplit] << " with budget " << budget[currentStateToSplit] << endl;
		//cout << "Has " << numUsed << " positions and " << weightNumForRegions.size() << " regions" << endl;
		//cout << "Weight: Dev=" << devWeight << " Mean=" << avgWeight << " lower=" << lowerWeightMean << " upper=" << upperWeightMean << " Min=" << lowerWeight << " Max=" << upperWeight << endl;
		//cout << "Cons: Dev=" << devCons << " Mean=" << avgCons << " lower=" << lowerConsMean << " upper=" << upperConsMean << " Min=" << lowerCons << " Max=" << upperCons << endl;


		//begin the EM loop
		bool doCons = devCons > devWeight;
		unsigned int numStates = 2;

		Vec<prob_type> newWeights;
		Vec<prob_type> newCons;
		if (doCons)
		{
			newWeights.push_back(avgWeight);
			newWeights.push_back(avgWeight);
			if (avgCons > devCons)
			{
				newCons.push_back(avgCons - devCons);
			}
			else
			{
				newCons.push_back(0);
			}

			if (avgCons + devCons < 1)
			{
				newCons.push_back(avgCons + devCons);
			}
			else
			{
				newCons.push_back(1);
			}

		}				
		else
		{
			if (avgWeight > devWeight)
			{
				newWeights.push_back(avgWeight - devWeight);
			}
			else
			{
				newWeights.push_back(0);
			}

			if (avgWeight + devWeight < 1)
			{
				newWeights.push_back(avgWeight + devWeight);
			}
			else
			{
				newWeights.push_back(1);
			}

			newCons.push_back(avgCons);
			newCons.push_back(avgCons);
		}

		Vec<unsigned int> counts;
		Vec<prob_type> sum;

		//get the list of regions
		Vec<unsigned int> begins;
		Vec<unsigned int> ends;
		unsigned int begin = 0;
		unsigned int end = 0;

		while (true)
		{
			begin = end;
			for (; begin < numPos; begin++)
			{
				if (stateNumbers[begin] == currentStateToSplit)
				{
					break;
				}
			}
			end = begin;
			for (; end < numPos; end++)
			{
				if (stateNumbers[end] != currentStateToSplit)
				{
					break;
				}
			}
			if (begin == end)
			{
				break;
			}
			begins.push_back(begin);
			ends.push_back(end);
		}

		const unsigned int maxEMIts = 5;

		for (unsigned int e = 0; e < maxEMIts; e++)
		{
			counts.clear();
			counts.resize(numStates, 0);
			sum.clear();
			sum.resize(numStates, 0);

			Vec<Vec<prob_type> > logTransitionProb(numStates);
			logTransitionProb[0].resize(numStates, 0);
			logTransitionProb[1].resize(numStates, 0);
			
			prob_type weightPeakDifference = fabs(newWeights.back() - newWeights.front());
			prob_type consPeakDifference = fabs(newCons.back() - newCons.front());
			
			prob_type weightPenalty = -1 * weightPeakDifference;
			prob_type consPenalty = -1 * consPeakDifference;
			
			prob_type penalty = (weightPenalty + consPenalty) * _minRegionLength;
			
			logTransitionProb[0][1] = penalty;
			logTransitionProb[1][0] = penalty;
			
			double aW = 0;
			double aC = 0;
			
			for (unsigned int r = 0; r < begins.size(); r++)
			{
				begin = begins[r];
				end = ends[r];

				unsigned int size = end - begin;
				//now we have determined the region we are about to split; go ahead and do viterbi
				
				//we first need to store the forward values
				Vec<Vec<prob_type> > values(numStates);
				Vec<Vec<output_type> > backPtrs(numStates);
				for (unsigned int i = 0; i != numStates; ++i)
				{
					values[i].resize(size, 0);
					backPtrs[i].resize(size, 0);
				}
				
				//base case
				for (unsigned int i = 0; i != numStates; ++i)
				{
					values[i][0] = getLinearEmissionValue(pv, begin, newWeights[i], newCons[i]);
					backPtrs[i][0] = 0;
				}
				
				//now recurse
				for (Vec<output_type>::size_type i = 0; i < size; i++)
				{
					aW += pv.getPresentProbability(i + begin);
					aC += pv.getMaxLetterProb(i + begin);
					
					for (unsigned int j = 0; j < numStates; j++)
					{
						//get the maxK
						output_type maxPrevState = 0;
						prob_type maxPrevValue = 0;
						bool havePrev = false;
						for (state_number_type k = 0; k < numStates; k++)
						{
							prob_type curVal = values[k][i - 1] + logTransitionProb[k][j];
							if (!havePrev || curVal > maxPrevValue)
							{
								havePrev = true;
								maxPrevValue = curVal;
								maxPrevState = k;
							}
						}
						
						//now update
						values[j][i] = maxPrevValue + getLinearEmissionValue(pv, i + begin, newWeights[j], newCons[j]);
						
						backPtrs[j][i] = maxPrevState;
						
					}
				}

				aW /= size;
				aC /= size;

				//now go in reverse
				output_type maxFinalState = 0;
				prob_type maxFinalValue = 0;
				bool haveFinalValue = false;
				for (unsigned int j = 0; j < numStates; j++)
				{
					if (!haveFinalValue || values[j][size - 1] > maxFinalValue)
					{
						maxFinalValue = values[j][size - 1];
						maxFinalState = j;
						haveFinalValue = true;
					}
				}
				
				stateNumbers[end - 1] = maxFinalState;
				for (Vec<output_type>::size_type i = size - 1; i > 0; i--)
				{
					unsigned int transi = i + begin;
					stateNumbers[transi - 1] = backPtrs[stateNumbers[transi]][i];
				} 

				unsigned int beginState = weights.size();
				for (Vec<output_type>::size_type i = begin; i < end; i++)
				{
					bool addCount = false;
					if (doCons)
					{
						sum[stateNumbers[i]] += pv.getMaxLetterProb(i);
						if (pv.getMaxLetterProb(i) > 0)
						{
							addCount = true;
						}
					}
					else
					{
						sum[stateNumbers[i]] += pv.getPresentProbability(i);
						if (pv.getPresentProbability(i) > 0)
						{
							addCount = true;
						}
					}
					if (addCount)
					{
						counts[stateNumbers[i]]++;
					}

					stateNumbers[i] += beginState;
				}
			}
			double ratio = static_cast<double>(counts[0]) / (counts[0] + counts[1]);

			double min = .4;
			if (ratio > min && ratio < 1 - min)
			{
				break;
			}

			//now we need to readjust the weights
			bool haveZero = counts[0] == 0 || counts[1] == 0;
			if (haveZero)
			{
				unsigned int numWithoutZero = counts[0] ? 0 : 1;
				if (doCons)
				{
					if (newCons[numWithoutZero] > devCons)
					{
						newCons[0] = newCons[numWithoutZero] - devCons;
					}
					else
					{
						newCons[0] = 0;
					}
					
					if (newCons[numWithoutZero] + devCons < 1)
					{
						newCons[1] = newCons[numWithoutZero] + devCons;
					}
					else
					{
						newCons[1] = 1;
					}
				}				
				else
				{
					if (newWeights[numWithoutZero] > devWeight)
					{
						newWeights[0] = newWeights[numWithoutZero] - devWeight;
					}
					else
					{
						newWeights[0] = 0;
					}
					
					if (newWeights[numWithoutZero] + devWeight < 1)
					{
						newWeights[1] = newWeights[numWithoutZero] + devWeight;
					}
					else
					{
						newWeights[1] = 1;
					}
				}
			}
			else
			{
				//go through and readjust
				if (doCons)
				{
					for (unsigned int s = 0; s < numStates; s++)
					{
						newCons[s] = sum[s] / counts[s];
					}
				}
				else
				{
					for (unsigned int s = 0; s < numStates; s++)
					{
						newWeights[s] = sum[s] / counts[s];
					}
				}
			}
			if (doCons)
			{
				if (newCons[1] < newCons[0])
				{
					prob_type temp = newCons[1];
					newCons[1] = newCons[0];
					newCons[0] = temp;
				}
			}
			else
			{
				if (newWeights[1] < newWeights[0])
				{
					prob_type temp = newWeights[1];
					newWeights[1] = newWeights[0];
					newWeights[0] = temp;
				}
			}
		}

		//now actually push the weights for the next two

		for (unsigned int i = 0; i < numStates; i++)
		{
			weights.push_back(newWeights[i]);
			consLevels.push_back(newCons[i]);
		}

		//budget.push_back(static_cast<unsigned int>((pow(weights[weights.size() - 2], gapPower) / (pow(weights[weights.size() - 1], gapPower) + pow(weights[weights.size() - 2], gapPower))) * budget[currentStateToSplit]));
		budget.push_back(budget[currentStateToSplit] / 2);

		if (!budget.back())
		{
			budget.back()++;
		}
		budget.push_back(budget[currentStateToSplit] - budget.back());

		//cout << "Pushed " << weights.size() - 2 << ": " << weights[weights.size() - 2] << "," << consLevels[consLevels.size() - 2] << " with " << counts[0] << " positions and budget of " << budget[budget.size() - 2] << endl;
		//cout << "Pushed " << weights.size() - 1 << ": " << weights[weights.size() - 1] << "," << consLevels[consLevels.size() - 1] << " with " << counts[1] << " positions and budget of " << budget[budget.size() - 1] << endl;

  }

	set<state_number_type> usedStateNumbers;
	for (Vec<output_type>::size_type i = 0; i < numPos; i++)
	{
		usedStateNumbers.insert(stateNumbers[i]);
	}

	//see how many regions can improve by moving to a better region class
	output_type currentOutput = stateNumbers[0];
	unsigned int startPos = 0;
	prob_type regionTotalWeight = pv.getPresentProbability(0);
	prob_type regionTotalCons = pv.getMaxLetterProb(0);
	unsigned int numReassigned = 0;
	unsigned int ss = 2874815;
	unsigned int se = 2874893;
	for (Vec<output_type>::size_type i = 1; i < numPos; i++)
	{
		if (stateNumbers[i] != currentOutput)
		{
			//test 
			prob_type regionAverageWeight = regionTotalWeight / (i - startPos);
			prob_type regionAverageCons = regionTotalCons / (i - startPos);
			state_number_type bestStateNumber = currentOutput;
			for (set<state_number_type>::iterator it = usedStateNumbers.begin(); it != usedStateNumbers.end(); it++)
			{
				if (fabs(weights[*it] - regionAverageWeight) < fabs(weights[bestStateNumber] - regionAverageWeight) &&
						fabs(consLevels[*it] - regionAverageCons) < fabs(consLevels[bestStateNumber] - regionAverageCons))
				{
					bestStateNumber = *it;
				}
			}

			if (startPos <= ss && i >= se)
			{
				//cout << "Region " << startPos << " - " << i - 1 << " assigned to " << weights[currentOutput] << "," << consLevels[currentOutput] << " with " << regionAverageWeight << "," << regionAverageCons << endl;
				//exit(0);
			}

			if (bestStateNumber != currentOutput)
			{
				for (Vec<output_type>::size_type j = startPos; j < i; j++)
				{
					stateNumbers[j] = bestStateNumber;
				}
				numReassigned++;
			}

			currentOutput = stateNumbers[i];
			startPos = i;
			regionTotalWeight = 0;
			regionTotalCons = 0;
		}
		regionTotalWeight += pv.getPresentProbability(i);
		regionTotalCons += pv.getMaxLetterProb(i);
	}	

	prob_type regionAverageWeight = regionTotalWeight / (numPos - startPos);
	prob_type regionAverageCons = regionTotalCons / (numPos - startPos);
	state_number_type bestStateNumber = currentOutput;

	for (set<state_number_type>::iterator it = usedStateNumbers.begin(); it != usedStateNumbers.end(); it++)
	{
		if (fabs(weights[*it] - regionAverageWeight) < fabs(weights[bestStateNumber] - regionAverageWeight) &&
				fabs(consLevels[*it] - regionAverageCons) < fabs(consLevels[bestStateNumber] - regionAverageCons))
		{
			bestStateNumber = *it;
		}
	}
	if (bestStateNumber != currentOutput)
	{
		for (Vec<output_type>::size_type j = startPos; j < numPos; j++)
		{
			stateNumbers[j] = bestStateNumber;
		}
		numReassigned++;
	}

	//renormalize the region classes
	map<state_number_type, prob_type> averageWeight;
	map<state_number_type, prob_type> averageCons;
	map<state_number_type, prob_type> numWeight;
	map<state_number_type, prob_type> numCons;

	for (Vec<output_type>::size_type i = 0; i < numPos; i++)
	{
		averageWeight[stateNumbers[i]] += pv.getPresentProbability(i);
		averageCons[stateNumbers[i]] += pv.getMaxLetterProb(i);
		numWeight[stateNumbers[i]]++;
		numCons[stateNumbers[i]]++;
	}

	for (map<state_number_type, prob_type>::iterator it = averageWeight.begin(); it != averageWeight.end(); it++)
	{
		//cout << "Readjusted state " << it->first << " weight from " << weights[it->first] << " to " << averageWeight[it->first] / numWeight[it->first] << endl;
		//cout << "Readjusted state " << it->first << " consLevel from " << consLevels[it->first] << " to " << averageCons[it->first] / numCons[it->first] << endl;
		weights[it->first] = averageWeight[it->first] / numWeight[it->first];
		consLevels[it->first] = averageCons[it->first] / numCons[it->first];
	}

	//now let's create the regions
	regionList.clear();
	Seq::size_type start = 0;
	Seq::size_type end = 0;	
	currentOutput = stateNumbers[0];

	for (Vec<output_type>::size_type i = 1; i < numPos; i++)
	{
		if (stateNumbers[i] != currentOutput)
		{
			Region r(start, end);
			regionList.addRegion(r, weights[currentOutput], consLevels[currentOutput]);
			start = i;
			end = i;
			currentOutput = stateNumbers[i];
		}
		else
		{
			end++;
		}
	}	
	Region r(start, end);
	regionList.addRegion(r, weights[currentOutput], consLevels[currentOutput]);

}


// SimpleHMM::prob_type SimpleHMM::getLogEmissionProbability(const ProbVector& pv, const ProbVector::size_type pos, prob_type weight, prob_type consLevel, prob_type weightDev, prob_type consDev)
// {
// 	prob_type weightDiff = pv.getPresentProbability(pos) - weight;
// 	prob_type consDiff = pv.getMaxLetterProb(pos) - consLevel;
// 	return (-1 * (weightDiff * weightDiff) / (2 * weightDev * weightDev)) - ((consDiff * consDiff) / (2 * consDev * consDev));
// }

SimpleHMM::prob_type SimpleHMM::getLinearEmissionValue(const ProbVector& pv, const ProbVector::size_type pos, prob_type weight, prob_type consLevel)
{
	prob_type weightDiff = fabs(pv.getPresentProbability(pos) - weight);
	prob_type consDiff = fabs(pv.getMaxLetterProb(pos) - consLevel);
	return -1 * (weightDiff + consDiff);
}

