#ifndef _simplehmm_h_included_
#define _simplehmm_h_included_

#include "System.h"
#include "ProbVector.h"
#include "Region.h"
#include "RegionList.h"
#include "Vec.h"
#include "Profile.h"
#include "Seq.h"
#include "Constants.h"
#include <string>
#include <iostream>


/**
 * A simple HMM
 */

class SimpleHMM
{
 public:

	typedef double prob_type;
	typedef double weight_type;
	typedef unsigned int output_type;
	typedef unsigned int state_number_type;

	SimpleHMM(Seq::size_type minRegionLength);

	//void decode(const ProbVector& pv, RegionList& regionList);

	void adaptiveDecode(const ProbVector& pv, const unsigned int numRegions, RegionList& regionList);

 private:
	
/* 	state_number_type getStateNumber(state_number_type weightNum, state_number_type consLevelNum) */
/* 		{ */
/* 			return weightNum * _numConsLevels + consLevelNum; */
/* 		} */

/* 	state_number_type getWeight(state_number_type stateNum) */
/* 		{ */
/* 			return stateNum / _numConsLevels; */
/* 		} */

/* 	state_number_type getConsLevel(state_number_type stateNum) */
/* 		{ */
/* 			return stateNum % _numConsLevels; */
/* 		} */


/* 	prob_type getLogEmissionProbability(const ProbVector& pv, const ProbVector::size_type pos, prob_type weight, prob_type consLevel, prob_type weightDev, prob_type consDev); */

	prob_type getLinearEmissionValue(const ProbVector& pv, const ProbVector::size_type pos, prob_type weight, prob_type consLevel);

	unsigned int _minRegionLength;
	state_number_type _numStates;
	Vec<Vec<prob_type> > _logTransitionProb;
	Vec<prob_type> _weights;
	Vec<prob_type>::size_type _numWeights;
	double _weightDev;
	Vec<prob_type> _consLevels;
	Vec<prob_type>::size_type _numConsLevels;
	double _consDev;

};

#endif
