#include "StaticPatternSetSelector.h"

void StaticPatternSetSelector::formatPatterns(TyphonNS::Pattern::size_type weight, TyphonNS::Pattern::size_type span, Vec<TyphonNS::Pattern>& patterns)
{
	if (patterns.size())
	{
		for (Vec<TyphonNS::Pattern>::iterator it = patterns.begin(); it != patterns.end(); ++it)
		{
			if (it->getKLength() < weight)
			{
				cerr << "Increasing weight: " << *it << " is now ";
				it->pad(weight - it->getKLength(), true);
				cerr << *it << endl;
			}
			else if (weight < it->getKLength())
			{
				cerr << "Decreasing weight: " << *it << " is now ";
				it->trunc(weight);				
				cerr << *it << endl;
			}
		}		
		//now all have the same weight.  We need to ensure all have the same span
		for (Vec<TyphonNS::Pattern>::iterator it = patterns.begin(); it != patterns.end(); ++it)
		{
			if (it->getPatternLength() < span)
			{
				cerr << "Increasing span: " << *it << " is now ";
				it->pad(span - it->getPatternLength(), false);
				cerr << *it << endl;
			}
			else if (span < it->getPatternLength())
			{
				cerr << "Decreasing span: " << *it << " is now ";
				it->trim(span);				
				cerr << *it << endl;
			}
		}
	}
} 
