#ifndef _util_h_included_
#define _util_h_included_

#include <cmath>

unsigned int fact(const unsigned int n)
{
	unsigned int result = 1;
	for (unsigned int i = 2; i < n; i++)
	{
		result *= i;
	}
	return result;
}

double eToRaw(double e, double l1, double l2, double K, double lambda)
{
	return log (e / (l1 * l2 * K)) / (-1 * lambda);
}

double rawToE(double raw, double l1, double l2, double K, double lambda)
{
	return exp(-1 * lambda * raw) * l1 * l2 * K;
}
double bitToRaw(double bit, double K, double lambda)
{
	return (bit * M_LN2 + log(K)) / lambda;
}

double rawToBit(double raw, double K, double lambda)
{
		return (lambda * raw - log(K)) / M_LN2;
}


#endif
